# wxStatusBar Class Reference
[Miscellaneous Windows]

`#include <wx/statusbr.h>`

Inheritance diagram for wxStatusBar:
[legend]

## Detailed Description

A status bar is a narrow window that can be placed along the bottom of a frame to give small amounts of status information.

It can contain one or more fields, one or more of which can be variable length according to the size of the window.

wxStatusBar also maintains an independent stack of status texts for each field (see PushStatusText() and PopStatusText()).

Note that in wxStatusBar context, the terms pane and field are synonyms.

## Styles

This class supports the following styles:

- wxSTB_SIZEGRIP:
  Displays a gripper at the right-hand side of the status bar which can be used to resize the parent window.
- wxSTB_SHOW_TIPS:
  Displays tooltips for those panes whose status text has been ellipsized/truncated because the status text doesn't fit the pane width. Note that this style has effect only on wxGTK (with GTK+ >= 2.12) currently.
- wxSTB_ELLIPSIZE_START:
  Replace the beginning of the status texts with an ellipsis when the status text widths exceed the status bar pane's widths (uses wxControl::Ellipsize).
- wxSTB_ELLIPSIZE_MIDDLE:
  Replace the middle of the status texts with an ellipsis when the status text widths exceed the status bar pane's widths (uses wxControl::Ellipsize).
- wxSTB_ELLIPSIZE_END:
  Replace the end of the status texts with an ellipsis when the status text widths exceed the status bar pane's widths (uses wxControl::Ellipsize).
- wxSTB_DEFAULT_STYLE:
  The default style: includes `wxSTB_SIZEGRIP|wxSTB_SHOW_TIPS|wxSTB_ELLIPSIZE_END|wxFULL_REPAINT_ON_RESIZE`.

Remarks:
  It is possible to create controls and other windows on the status bar. Position these windows from an OnSize() event handler.

  Notice that only the first 127 characters of a string will be shown in status bar fields under pre-XP MSW systems (or even under later systems if a proper manifest indicating that the program uses version 6 of common controls library is not used). This is a limitation of the native control on these platforms.

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  wxStatusBarPane, wxFrame, Status Bar Sample

## Public Member Functions
| wxStatusBar ()
| Default ctor.
| wxStatusBar (wxWindow *parent, wxWindowID id=wxID_ANY, long style=wxSTB_DEFAULT_STYLE, const wxString &name=wxStatusBarNameStr)
| Constructor, creating the window.
virtual | ~wxStatusBar ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, long style=wxSTB_DEFAULT_STYLE, const wxString &name=wxStatusBarNameStr)
| Creates the window, for two-step construction.
virtual bool | GetFieldRect (int i, wxRect &rect) const
| Returns the size and position of a field's internal bounding rectangle.
int | GetFieldsCount () const
| Returns the number of fields in the status bar.
const wxStatusBarPane & | GetField (int n) const
| Returns the wxStatusBarPane representing the n-th field.
wxSize | GetBorders () const
| Returns the horizontal and vertical borders used when rendering the field text inside the field area.
virtual wxString | GetStatusText (int i=0) const
| Returns the string associated with a status bar field.
int | GetStatusWidth (int n) const
| Returns the width of the n-th field.
int | GetStatusStyle (int n) const
| Returns the style of the n-th field.
void | PopStatusText (int field=0)
| Restores the text to the value it had before the last call to PushStatusText().
void | PushStatusText (const wxString &string, int field=0)
| Saves the current field text in a per-field stack, and sets the field text to the string passed as argument.
virtual void | SetFieldsCount (int number=1, const int *widths=NULL)
| Sets the number of fields, and optionally the field widths.
virtual void | SetMinHeight (int height)
| Sets the minimal possible height for the status bar.
virtual void | SetStatusStyles (int n, const int *styles)
| Sets the styles of the fields in the status line which can make fields appear flat or raised instead of the standard sunken 3D border.
virtual void | SetStatusText (const wxString &text, int i=0)
| Sets the status text for the i-th field.
virtual void | SetStatusWidths (int n, const int *widths_field)
| Sets the widths of the fields in the status line.

List of all members.

## Constructor & Destructor Documentation

wxStatusBar::wxStatusBar | ( |  | ) |

Default ctor.

wxStatusBar::wxStatusBar | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | long | style = `wxSTB_DEFAULT_STYLE`,
|  | const wxString & | name = `wxStatusBarNameStr` |
| ) |  |  |

Constructor, creating the window.

Parameters:

  | parent | The window parent, usually a frame.
  | id | The window identifier. It may take a value of -1 to indicate a default value.
  | style | The window style. See wxStatusBar.
  | name | The name of the window. This parameter is used to associate a name with the item, allowing the application user to set Motif resource values for individual windows.

See also:
  Create()

virtual wxStatusBar::~wxStatusBar | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

bool wxStatusBar::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | long | style = `wxSTB_DEFAULT_STYLE`,
|  | const wxString & | name = `wxStatusBarNameStr` |
| ) |  |  |

Creates the window, for two-step construction.

See wxStatusBar() for details.

wxSize wxStatusBar::GetBorders | ( |  | ) | const

Returns the horizontal and vertical borders used when rendering the field text inside the field area.

Note that the rect returned by GetFieldRect() already accounts for the presence of horizontal and vertical border returned by this function.

const wxStatusBarPane& wxStatusBar::GetField | ( | int | n | ) | const

Returns the wxStatusBarPane representing the n-th field.

virtual bool wxStatusBar::GetFieldRect | ( | int | i,
|  | wxRect & | rect |
| ) |  |  | const`[virtual]`

Returns the size and position of a field's internal bounding rectangle.

Parameters:

  | i | The field in question.
  | rect | The rectangle values are placed in this variable.

Returns:
  true if the field index is valid, false otherwise.

wxPerl Note: In wxPerl this function returns a `Wx::Rect` if the field index is valid, `undef` otherwise.

See also:
  wxRect

int wxStatusBar::GetFieldsCount | ( |  | ) | const

Returns the number of fields in the status bar.

int wxStatusBar::GetStatusStyle | ( | int | n | ) | const

Returns the style of the n-th field.

See wxStatusBarPane::GetStyle() for more info.

virtual wxString wxStatusBar::GetStatusText | ( | int | i = `0` | ) | const`[virtual]`

Returns the string associated with a status bar field.

Parameters:

  | i | The number of the status field to retrieve, starting from zero.

Returns:
  The status field string if the field is valid, otherwise the empty string.

See also:
  SetStatusText()

int wxStatusBar::GetStatusWidth | ( | int | n | ) | const

Returns the width of the n-th field.

See wxStatusBarPane::GetWidth() for more info.

void wxStatusBar::PopStatusText | ( | int | field = `0` | ) |

Restores the text to the value it had before the last call to PushStatusText().

Notice that if SetStatusText() had been called in the meanwhile, PopStatusText() will not change the text, i.e. it does not override explicit changes to status text but only restores the saved text if it hadn't been changed since.

See also:
  PushStatusText()

void wxStatusBar::PushStatusText | ( | const wxString & | string,
|  | int | field = `0` |
| ) |  |  |

Saves the current field text in a per-field stack, and sets the field text to the string passed as argument.

See also:
  PopStatusText()

virtual void wxStatusBar::SetFieldsCount | ( | int | number = `1`,
|  | const int * | widths = `NULL` |
| ) |  |  | `[virtual]`

Sets the number of fields, and optionally the field widths.

Parameters:

  | number | The number of fields. If this is greater than the previous number, then new fields with empty strings will be added to the status bar.
  | widths | An array of n integers interpreted in the same way as in SetStatusWidths().

wxPerl Note: In wxPerl this function accepts only the number parameter. Use SetStatusWidths to set the field widths.

virtual void wxStatusBar::SetMinHeight | ( | int | height | ) | `[virtual]`

Sets the minimal possible height for the status bar.

The real height may be bigger than the height specified here depending on the size of the font used by the status bar.

virtual void wxStatusBar::SetStatusStyles | ( | int | n,
|  | const int * | styles |
| ) |  |  | `[virtual]`

Sets the styles of the fields in the status line which can make fields appear flat or raised instead of the standard sunken 3D border.

Parameters:

  | n | The number of fields in the status bar. Must be equal to the number passed to SetFieldsCount() the last time it was called.
  | styles | Contains an array of n integers with the styles for each field. There are three possible styles: `wxSB_NORMAL` (default): The field appears sunken with a standard 3D border. `wxSB_FLAT:` No border is painted around the field so that it appears flat. `wxSB_RAISED:` A raised 3D border is painted around the field.

virtual void wxStatusBar::SetStatusText | ( | const wxString & | text,
|  | int | i = `0` |
| ) |  |  | `[virtual]`

Sets the status text for the i-th field.

The given text will replace the current text.

Note that if PushStatusText() had been called before the new text will also replace the last saved value to make sure that the next call to PopStatusText() doesn't restore the old value, which was overwritten by the call to this function.

Parameters:

  | text | The text to be set. Use an empty string ("") to clear the field.
  | i | The field to set, starting from zero.

See also:
  GetStatusText(), wxFrame::SetStatusText

virtual void wxStatusBar::SetStatusWidths | ( | int | n,
|  | const int * | widths_field |
| ) |  |  | `[virtual]`

Sets the widths of the fields in the status line.

There are two types of fields: fixed widths and variable width fields. For the fixed width fields you should specify their (constant) width in pixels. For the variable width fields, specify a negative number which indicates how the field should expand: the space left for all variable width fields is divided between them according to the absolute value of this number. A variable width field with width of -2 gets twice as much of it as a field with width -1 and so on.

For example, to create one fixed width field of width 100 in the right part of the status bar and two more fields which get 66% and 33% of the remaining space correspondingly, you should use an array containing -2, -1 and 100.

Parameters:

  | n | The number of fields in the status bar. Must be equal to the number passed to SetFieldsCount() the last time it was called.
  | widths_field | Contains an array of n integers, each of which is either an absolute status field width in pixels if positive or indicates a variable width field if negative. The special value NULL means that all fields should get the same width.

Remarks:
  The widths of the variable fields are calculated from the total width of all fields, minus the sum of widths of the non-variable fields, divided by the number of variable fields.

wxPerl Note: In wxPerl this method takes as parameters the field widths.

See also:
  SetFieldsCount(), wxFrame::SetStatusWidths()

|  | [ top ]